# -*- coding: utf-8 -*-
from ipyflow.annotations import (
    MutatingMethodEventNotYetImplemented,
    NamespaceClear,
    NoopCallHandler,
)
from ipyflow.tracing.external_calls.base_handlers import CallerMutation
from ipyflow.tracing.external_calls.list_handlers import (
    ListAppend,
    ListExtend,
    ListInsert,
    ListPop,
    ListRemove,
)

class dict:
    def __getitem__(self) -> NoopCallHandler: ...
    def get(self) -> NoopCallHandler: ...
    def clear(self) -> NamespaceClear: ...
    def pop(self) -> MutatingMethodEventNotYetImplemented: ...
    def popitem(self) -> MutatingMethodEventNotYetImplemented: ...
    def setdefault(self) -> MutatingMethodEventNotYetImplemented: ...
    def update(self) -> MutatingMethodEventNotYetImplemented: ...

class list:
    def __getitem__(self) -> NoopCallHandler: ...
    def append(self) -> ListAppend: ...
    def clear(self) -> NamespaceClear: ...
    def extend(self) -> ListExtend: ...
    def insert(self) -> ListInsert: ...
    def remove(self) -> ListRemove: ...
    def pop(self) -> ListPop: ...
    def sort(self) -> CallerMutation: ...

class set:
    def clear(self) -> MutatingMethodEventNotYetImplemented: ...
    def difference_update(self) -> MutatingMethodEventNotYetImplemented: ...
    def discard(self) -> MutatingMethodEventNotYetImplemented: ...
    def intersection_update(self) -> MutatingMethodEventNotYetImplemented: ...
    def pop(self) -> MutatingMethodEventNotYetImplemented: ...
    def remove(self) -> MutatingMethodEventNotYetImplemented: ...
    def symmetric_difference_update(self) -> MutatingMethodEventNotYetImplemented: ...
    def update(self) -> MutatingMethodEventNotYetImplemented: ...
